<?php

namespace Drupal\rest_block_data\Normalizer;

use Drupal\serialization\Normalizer\ConfigEntityNormalizer;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Entity\EntityTypeRepositoryInterface;
use Drupal\Core\Entity\EntityFieldManagerInterface;

use Drupal\rest_block_data\Plugin\Block\BlockInterface;

/**
 * Normalizes block objects into an array structure.
 */
class BlockNormalizer extends ConfigEntityNormalizer
{
    /**
     * {@inheritdoc}
     */
    protected $supportedInterfaceOrClass = \Drupal\block\BlockInterface::class;

    /**
     * {@inheritdoc}
     */
    public function __construct(
        EntityTypeManagerInterface $entity_type_manager,
        EntityTypeRepositoryInterface $entity_type_repository = NULL,
        EntityFieldManagerInterface $entity_field_manager = NULL
    ) {
        parent::__construct($entity_type_manager, $entity_type_repository, $entity_field_manager);
    }

    /**
     * {@inheritdoc}
     */
    public function normalize($object, $format = NULL, array $context = array())
    {
        $normalized = parent::normalize($object, $format, $context);

        if (!$object->getPlugin() instanceof BlockInterface) {
            return $normalized;
        }

        $normalized['data'] = $this->serializer->normalize($object->getPlugin()->buildToRest(), $format, $context);

        return $normalized;
    }
}
