<?php

namespace Drupal\rest_block_data\Normalizer;

use Drupal\serialization\Normalizer\NormalizerBase;

/**
 * View result row normalizer
 */
class ResultRowNormalizer extends NormalizerBase
{
    /**
     * {@inheritdoc}
     */
    protected $supportedInterfaceOrClass = \Drupal\views\ResultRow::class;

    /**
     * {@inheritdoc}
     */
    public function normalize($object, $format = NULL, array $context = array())
    {
        $normalized = [];

        $entity = \Drupal::service('entity.repository')->getTranslationFromContext($object->_entity);
        $fields = $context['field'];

        if ($fields) {
            foreach ($fields as $fid => $field) {
                if ($entity->hasField($fid)) {
                    $normalized[$fid] = $this->serializer->normalize($entity->get($fid), $format, $context);
                } else {
                    $normalized[$fid] = $field->render($object);
                }
            }
        } else {
            $normalized = $this->serializer->normalize($entity, $format, $context);
        }

        return $normalized;
    }
}
